· · ·
Public Types | Public Functions | Public Members | Signals | Protected Functions
QCustomPlot Class Reference

The central class of the library. This is the QWidget which displays the plot and interacts with the user. More...

## Public Types
enum | LayerInsertMode
enum | RefreshPriority

## Public Functions
| QCustomPlot (QWidget *parent=0)
QRect | viewport () const
QPixmap | background () const
bool | backgroundScaled () const
Qt::AspectRatioMode | backgroundScaledMode () const
QCPLayoutGrid * | plotLayout () const
QCP::AntialiasedElements | antialiasedElements () const
QCP::AntialiasedElements | notAntialiasedElements () const
bool | autoAddPlottableToLegend () const
const QCP::Interactions | interactions () const
int | selectionTolerance () const
bool | noAntialiasingOnDrag () const
QCP::PlottingHints | plottingHints () const
Qt::KeyboardModifier | multiSelectModifier () const
void | setViewport (const QRect &rect)
void | setBackground (const QPixmap &pm)
void | setBackground (const QPixmap &pm, bool scaled, Qt::AspectRatioMode mode=Qt::KeepAspectRatioByExpanding)
void | setBackground (const QBrush &brush)
void | setBackgroundScaled (bool scaled)
void | setBackgroundScaledMode (Qt::AspectRatioMode mode)
void | setAntialiasedElements (const QCP::AntialiasedElements &antialiasedElements)
void | setAntialiasedElement (QCP::AntialiasedElement antialiasedElement, bool enabled=true)
void | setNotAntialiasedElements (const QCP::AntialiasedElements &notAntialiasedElements)
void | setNotAntialiasedElement (QCP::AntialiasedElement notAntialiasedElement, bool enabled=true)
void | setAutoAddPlottableToLegend (bool on)
void | setInteractions (const QCP::Interactions &interactions)
void | setInteraction (const QCP::Interaction &interaction, bool enabled=true)
void | setSelectionTolerance (int pixels)
void | setNoAntialiasingOnDrag (bool enabled)
void | setPlottingHints (const QCP::PlottingHints &hints)
void | setPlottingHint (QCP::PlottingHint hint, bool enabled=true)
void | setMultiSelectModifier (Qt::KeyboardModifier modifier)
QCPAbstractPlottable * | plottable (int index)
QCPAbstractPlottable * | plottable ()
bool | addPlottable (QCPAbstractPlottable *plottable)
bool | removePlottable (QCPAbstractPlottable *plottable)
bool | removePlottable (int index)
int | clearPlottables ()
int | plottableCount () const
QList< QCPAbstractPlottable * > | selectedPlottables () const
QCPAbstractPlottable * | plottableAt (const QPointF &pos, bool onlySelectable=false) const
bool | hasPlottable (QCPAbstractPlottable *plottable) const
QCPGraph * | graph (int index) const
QCPGraph * | graph () const
QCPGraph * | addGraph (QCPAxis *keyAxis=0, QCPAxis *valueAxis=0)
bool | removeGraph (QCPGraph *graph)
bool | removeGraph (int index)
int | clearGraphs ()
int | graphCount () const
QList< QCPGraph * > | selectedGraphs () const
QCPAbstractItem * | item (int index) const
QCPAbstractItem * | item () const
bool | addItem (QCPAbstractItem *item)
bool | removeItem (QCPAbstractItem *item)
bool | removeItem (int index)
int | clearItems ()
int | itemCount () const
QList< QCPAbstractItem * > | selectedItems () const
QCPAbstractItem * | itemAt (const QPointF &pos, bool onlySelectable=false) const
bool | hasItem (QCPAbstractItem *item) const
QCPLayer * | layer (const QString &name) const
QCPLayer * | layer (int index) const
QCPLayer * | currentLayer () const
bool | setCurrentLayer (const QString &name)
bool | setCurrentLayer (QCPLayer *layer)
int | layerCount () const
bool | addLayer (const QString &name, QCPLayer *otherLayer=0, LayerInsertMode insertMode=limAbove)
bool | removeLayer (QCPLayer *layer)
bool | moveLayer (QCPLayer *layer, QCPLayer *otherLayer, LayerInsertMode insertMode=limAbove)
int | axisRectCount () const
QCPAxisRect * | axisRect (int index=0) const
QList< QCPAxisRect * > | axisRects () const
QCPLayoutElement * | layoutElementAt (const QPointF &pos) const
Q_SLOT void | rescaleAxes (bool onlyVisiblePlottables=false)
QList< QCPAxis * > | selectedAxes () const
QList< QCPLegend * > | selectedLegends () const
Q_SLOT void | deselectAll ()
bool | savePdf (const QString &fileName, bool noCosmeticPen=false, int width=0, int height=0, const QString &pdfCreator="", const QString &pdfTitle="")
bool | savePng (const QString &fileName, int width=0, int height=0, double scale=1.0, int quality=-1)
bool | saveJpg (const QString &fileName, int width=0, int height=0, double scale=1.0, int quality=-1)
bool | saveBmp (const QString &fileName, int width=0, int height=0, double scale=1.0)
bool | saveRastered (const QString &fileName, int width, int height, double scale, const char *format, int quality=-1)
QPixmap | toPixmap (int width=0, int height=0, double scale=1.0)
void | toPainter (QCPPainter *painter, int width=0, int height=0)
Q_SLOT void | replot (QCustomPlot::RefreshPriority refreshPriority=QCustomPlot::rpHint)

## Public Members
QCPAxis * | xAxis
QCPAxis * | yAxis
QCPAxis * | xAxis2
QCPAxis * | yAxis2
QCPLegend * | legend

## Signals
void | mouseDoubleClick (QMouseEvent *event)
void | mousePress (QMouseEvent *event)
void | mouseMove (QMouseEvent *event)
void | mouseRelease (QMouseEvent *event)
void | mouseWheel (QWheelEvent *event)
void | plottableClick (QCPAbstractPlottable *plottable, QMouseEvent *event)
void | plottableDoubleClick (QCPAbstractPlottable *plottable, QMouseEvent *event)
void | itemClick (QCPAbstractItem *item, QMouseEvent *event)
void | itemDoubleClick (QCPAbstractItem *item, QMouseEvent *event)
void | axisClick (QCPAxis *axis, QCPAxis::SelectablePart part, QMouseEvent *event)
void | axisDoubleClick (QCPAxis *axis, QCPAxis::SelectablePart part, QMouseEvent *event)
void | legendClick (QCPLegend *legend, QCPAbstractLegendItem *item, QMouseEvent *event)
void | legendDoubleClick (QCPLegend *legend, QCPAbstractLegendItem *item, QMouseEvent *event)
void | titleClick (QMouseEvent *event, QCPPlotTitle *title)
void | titleDoubleClick (QMouseEvent *event, QCPPlotTitle *title)
void | selectionChangedByUser ()
void | beforeReplot ()
void | afterReplot ()

## Protected Functions
virtual QSize | minimumSizeHint () const
virtual QSize | sizeHint () const
virtual void | paintEvent (QPaintEvent *event)
virtual void | resizeEvent (QResizeEvent *event)
virtual void | mouseDoubleClickEvent (QMouseEvent *event)
virtual void | mousePressEvent (QMouseEvent *event)
virtual void | mouseMoveEvent (QMouseEvent *event)
virtual void | mouseReleaseEvent (QMouseEvent *event)
virtual void | wheelEvent (QWheelEvent *event)
virtual void | draw (QCPPainter *painter)
virtual void | axisRemoved (QCPAxis *axis)
virtual void | legendRemoved (QCPLegend *legend)
void | updateLayerIndices () const
QCPLayerable * | layerableAt (const QPointF &pos, bool onlySelectable, QVariant *selectionDetails=0) const
void | drawBackground (QCPPainter *painter)

## Detailed Description

The central class of the library. This is the QWidget which displays the plot and interacts with the user.

For tutorials on how to use QCustomPlot, see the website
http://www.qcustomplot.com/

## Member Enumeration Documentation

enum QCustomPlot::LayerInsertMode

Defines how a layer should be inserted relative to an other layer.

See Also
  addLayer, moveLayer

Enumerator:

  limBelow | Layer is inserted below other layer.
  limAbove | Layer is inserted above other layer.

enum QCustomPlot::RefreshPriority

Defines with what timing the QCustomPlot surface is refreshed after a replot.

See Also
  replot

Enumerator:

  rpImmediate | The QCustomPlot surface is immediately refreshed, by calling QWidget::repaint() after the replot.
  rpQueued | Queues the refresh such that it is performed at a slightly delayed point in time after the replot, by calling QWidget::update() after the replot.
  rpHint | Whether to use immediate repaint or queued update depends on whether the plotting hint QCP::phForceRepaint is set, see setPlottingHints.

## Constructor & Destructor Documentation

QCustomPlot::QCustomPlot | ( | QWidget * | parent = `0` | ) |
| explicit

Constructs a QCustomPlot and sets reasonable default values.

## Member Function Documentation

QRect QCustomPlot::viewport | ( |  | ) | const
| inline

Returns the viewport rect of this QCustomPlot instance. The viewport is the area the plot is drawn in, all mechanisms, e.g. margin caluclation take the viewport to be the outer border of the plot. The viewport normally is the rect() of the QCustomPlot widget, i.e. a rect with top left (0, 0) and size of the QCustomPlot widget.

Don't confuse the viewport with the axis rect (QCustomPlot::axisRect). An axis rect is typically an area enclosed by four axes, where the graphs/plottables are drawn in. The viewport is larger and contains also the axes themselves, their tick numbers, their labels, the plot title etc.

Only when saving to a file (see savePng, savePdf etc.) the viewport is temporarily modified to allow saving plots with sizes independent of the current widget size.

QCPLayoutGrid * QCustomPlot::plotLayout | ( |  | ) | const
| inline

Returns the top level layout of this QCustomPlot instance. It is a QCPLayoutGrid, initially containing just one cell with the main QCPAxisRect inside.

void QCustomPlot::setViewport | ( | const QRect & | rect | ) |

Sets the viewport of this QCustomPlot. The Viewport is the area that the top level layout (QCustomPlot::plotLayout()) uses as its rect. Normally, the viewport is the entire widget rect.

This function is used to allow arbitrary size exports with toPixmap, savePng, savePdf, etc. by temporarily changing the viewport size.

void QCustomPlot::setBackground | ( | const QPixmap & | pm | ) |

Sets pm as the viewport background pixmap (see setViewport). The pixmap is always drawn below all other objects in the plot.

For cases where the provided pixmap doesn't have the same size as the viewport, scaling can be enabled with setBackgroundScaled and the scaling mode (whether and how the aspect ratio is preserved) can be set with setBackgroundScaledMode. To set all these options in one call, consider using the overloaded version of this function.

If a background brush was set with setBackground(const QBrush &brush), the viewport will first be filled with that brush, before drawing the background pixmap. This can be useful for background pixmaps with translucent areas.

See Also
  setBackgroundScaled, setBackgroundScaledMode

void QCustomPlot::setBackground | ( | const QPixmap & | pm,
|  | bool | scaled,
|  | Qt::AspectRatioMode | mode = `Qt::KeepAspectRatioByExpanding`
| ) |  |

This is an overloaded function.

Allows setting the background pixmap of the viewport, whether it shall be scaled and how it shall be scaled in one call.

See Also
  setBackground(const QPixmap &pm), setBackgroundScaled, setBackgroundScaledMode

void QCustomPlot::setBackground | ( | const QBrush & | brush | ) |

Sets the background brush of the viewport (see setViewport).

Before drawing everything else, the background is filled with brush. If a background pixmap was set with setBackground(const QPixmap &pm), this brush will be used to fill the viewport before the background pixmap is drawn. This can be useful for background pixmaps with translucent areas.

Set brush to Qt::NoBrush or Qt::Transparent to leave background transparent. This can be useful for exporting to image formats which support transparency, e.g. savePng.

See Also
  setBackgroundScaled, setBackgroundScaledMode

void QCustomPlot::setBackgroundScaled | ( | bool | scaled | ) |

Sets whether the viewport background pixmap shall be scaled to fit the viewport. If scaled is set to true, control whether and how the aspect ratio of the original pixmap is preserved with setBackgroundScaledMode.

Note that the scaled version of the original pixmap is buffered, so there is no performance penalty on replots. (Except when the viewport dimensions are changed continuously.)

See Also
  setBackground, setBackgroundScaledMode

void QCustomPlot::setBackgroundScaledMode | ( | Qt::AspectRatioMode | mode | ) |

If scaling of the viewport background pixmap is enabled (setBackgroundScaled), use this function to define whether and how the aspect ratio of the original pixmap is preserved.

See Also
  setBackground, setBackgroundScaled

void QCustomPlot::setAntialiasedElements | ( | const QCP::AntialiasedElements & | antialiasedElements | ) |

Sets which elements are forcibly drawn antialiased as an or combination of QCP::AntialiasedElement.

This overrides the antialiasing settings for whole element groups, normally controlled with the setAntialiasing function on the individual elements. If an element is neither specified in setAntialiasedElements nor in setNotAntialiasedElements, the antialiasing setting on each individual element instance is used.

For example, if antialiasedElements contains QCP::aePlottables, all plottables will be drawn antialiased, no matter what the specific QCPAbstractPlottable::setAntialiased value was set to.

if an element in antialiasedElements is already set in setNotAntialiasedElements, it is removed from there.

See Also
  setNotAntialiasedElements

void QCustomPlot::setAntialiasedElement | ( | QCP::AntialiasedElement | antialiasedElement,
|  | bool | enabled = `true`
| ) |  |

Sets whether the specified antialiasedElement is forcibly drawn antialiased.

See setAntialiasedElements for details.

See Also
  setNotAntialiasedElement

void QCustomPlot::setNotAntialiasedElements | ( | const QCP::AntialiasedElements & | notAntialiasedElements | ) |

Sets which elements are forcibly drawn not antialiased as an or combination of QCP::AntialiasedElement.

This overrides the antialiasing settings for whole element groups, normally controlled with the setAntialiasing function on the individual elements. If an element is neither specified in setAntialiasedElements nor in setNotAntialiasedElements, the antialiasing setting on each individual element instance is used.

For example, if notAntialiasedElements contains QCP::aePlottables, no plottables will be drawn antialiased, no matter what the specific QCPAbstractPlottable::setAntialiased value was set to.

if an element in notAntialiasedElements is already set in setAntialiasedElements, it is removed from there.

See Also
  setAntialiasedElements

void QCustomPlot::setNotAntialiasedElement | ( | QCP::AntialiasedElement | notAntialiasedElement,
|  | bool | enabled = `true`
| ) |  |

Sets whether the specified notAntialiasedElement is forcibly drawn not antialiased.

See setNotAntialiasedElements for details.

See Also
  setAntialiasedElement

void QCustomPlot::setAutoAddPlottableToLegend | ( | bool | on | ) |

If set to true, adding a plottable (e.g. a graph) to the QCustomPlot automatically also adds the plottable to the legend (QCustomPlot::legend).

See Also
  addPlottable, addGraph, QCPLegend::addItem

void QCustomPlot::setInteractions | ( | const QCP::Interactions & | interactions | ) |

Sets the possible interactions of this QCustomPlot as an or-combination of QCP::Interaction enums. There are the following types of interactions:

Axis range manipulation is controlled via QCP::iRangeDrag and QCP::iRangeZoom. When the respective interaction is enabled, the user may drag axes ranges and zoom with the mouse wheel. For details how to control which axes the user may drag/zoom and in what orientations, see QCPAxisRect::setRangeDrag, QCPAxisRect::setRangeZoom, QCPAxisRect::setRangeDragAxes, QCPAxisRect::setRangeZoomAxes.

Plottable selection is controlled by QCP::iSelectPlottables. If QCP::iSelectPlottables is set, the user may select plottables (graphs, curves, bars,...) by clicking on them or in their vicinity (setSelectionTolerance). Whether the user can actually select a plottable can further be restricted with the QCPAbstractPlottable::setSelectable function on the specific plottable. To find out whether a specific plottable is selected, call QCPAbstractPlottable::selected(). To retrieve a list of all currently selected plottables, call selectedPlottables. If you're only interested in QCPGraphs, you may use the convenience function selectedGraphs.

Item selection is controlled by QCP::iSelectItems. If QCP::iSelectItems is set, the user may select items (QCPItemLine, QCPItemText,...) by clicking on them or in their vicinity. To find out whether a specific item is selected, call QCPAbstractItem::selected(). To retrieve a list of all currently selected items, call selectedItems.

Axis selection is controlled with QCP::iSelectAxes. If QCP::iSelectAxes is set, the user may select parts of the axes by clicking on them. What parts exactly (e.g. Axis base line, tick labels, axis label) are selectable can be controlled via QCPAxis::setSelectableParts for each axis. To retrieve a list of all axes that currently contain selected parts, call selectedAxes. Which parts of an axis are selected, can be retrieved with QCPAxis::selectedParts().

Legend selection is controlled with QCP::iSelectLegend. If this is set, the user may select the legend itself or individual items by clicking on them. What parts exactly are selectable can be controlled via QCPLegend::setSelectableParts. To find out whether the legend or any of its child items are selected, check the value of QCPLegend::selectedParts. To find out which child items are selected, call QCPLegend::selectedItems.

All other selectable elements The selection of all other selectable objects (e.g. QCPPlotTitle, or your own layerable subclasses) is controlled with QCP::iSelectOther. If set, the user may select those objects by clicking on them. To find out which are currently selected, you need to check their selected state explicitly.

If the selection state has changed by user interaction, the selectionChangedByUser signal is emitted. Each selectable object additionally emits an individual selectionChanged signal whenever their selection state has changed, i.e. not only by user interaction.

To allow multiple objects to be selected by holding the selection modifier (setMultiSelectModifier), set the flag QCP::iMultiSelect.

Note
  In addition to the selection mechanism presented here, QCustomPlot always emits corresponding signals, when an object is clicked or double clicked. see plottableClick and plottableDoubleClick for example.

See Also
  setInteraction, setSelectionTolerance

void QCustomPlot::setInteraction | ( | const QCP::Interaction & | interaction,
|  | bool | enabled = `true`
| ) |  |

Sets the single interaction of this QCustomPlot to enabled.

For details about the interaction system, see setInteractions.

See Also
  setInteractions

void QCustomPlot::setSelectionTolerance | ( | int | pixels | ) |

Sets the tolerance that is used to decide whether a click selects an object (e.g. a plottable) or not.

If the user clicks in the vicinity of the line of e.g. a QCPGraph, it's only regarded as a potential selection when the minimum distance between the click position and the graph line is smaller than pixels. Objects that are defined by an area (e.g. QCPBars) only react to clicks directly inside the area and ignore this selection tolerance. In other words, it only has meaning for parts of objects that are too thin to exactly hit with a click and thus need such a tolerance.

See Also
  setInteractions, QCPLayerable::selectTest

void QCustomPlot::setNoAntialiasingOnDrag | ( | bool | enabled | ) |

Sets whether antialiasing is disabled for this QCustomPlot while the user is dragging axes ranges. If many objects, especially plottables, are drawn antialiased, this greatly improves performance during dragging. Thus it creates a more responsive user experience. As soon as the user stops dragging, the last replot is done with normal antialiasing, to restore high image quality.

See Also
  setAntialiasedElements, setNotAntialiasedElements

void QCustomPlot::setPlottingHints | ( | const QCP::PlottingHints & | hints | ) |

Sets the plotting hints for this QCustomPlot instance as an or combination of QCP::PlottingHint.

See Also
  setPlottingHint

void QCustomPlot::setPlottingHint | ( | QCP::PlottingHint | hint,
|  | bool | enabled = `true`
| ) |  |

Sets the specified plotting hint to enabled.

See Also
  setPlottingHints

void QCustomPlot::setMultiSelectModifier | ( | Qt::KeyboardModifier | modifier | ) |

Sets the keyboard modifier that will be recognized as multi-select-modifier.

If QCP::iMultiSelect is specified in setInteractions, the user may select multiple objects by clicking on them one after the other while holding down modifier.

By default the multi-select-modifier is set to Qt::ControlModifier.

See Also
  setInteractions

QCPAbstractPlottable * QCustomPlot::plottable | ( | int | index | ) |

Returns the plottable with index. If the index is invalid, returns 0.

There is an overloaded version of this function with no parameter which returns the last added plottable, see QCustomPlot::plottable()

See Also
  plottableCount, addPlottable

QCPAbstractPlottable * QCustomPlot::plottable | ( |  | ) |

This is an overloaded function.

Returns the last plottable that was added with addPlottable. If there are no plottables in the plot, returns 0.

See Also
  plottableCount, addPlottable

bool QCustomPlot::addPlottable | ( | QCPAbstractPlottable * | plottable | ) |

Adds the specified plottable to the plot and, if setAutoAddPlottableToLegend is enabled, to the legend (QCustomPlot::legend). QCustomPlot takes ownership of the plottable.

Returns true on success, i.e. when plottable isn't already in the plot and the parent plot of plottable is this QCustomPlot (the latter is controlled by what axes were passed in the plottable's constructor).

See Also
  plottable, plottableCount, removePlottable, clearPlottables

bool QCustomPlot::removePlottable | ( | QCPAbstractPlottable * | plottable | ) |

Removes the specified plottable from the plot and, if necessary, from the legend (QCustomPlot::legend).

Returns true on success.

See Also
  addPlottable, clearPlottables

bool QCustomPlot::removePlottable | ( | int | index | ) |

This is an overloaded function.

Removes the plottable by its index.

int QCustomPlot::clearPlottables | ( |  | ) |

Removes all plottables from the plot (and the QCustomPlot::legend, if necessary).

Returns the number of plottables removed.

See Also
  removePlottable

int QCustomPlot::plottableCount | ( |  | ) | const

Returns the number of currently existing plottables in the plot

See Also
  plottable, addPlottable

QList< QCPAbstractPlottable * > QCustomPlot::selectedPlottables | ( |  | ) | const

Returns a list of the selected plottables. If no plottables are currently selected, the list is empty.

There is a convenience function if you're only interested in selected graphs, see selectedGraphs.

See Also
  setInteractions, QCPAbstractPlottable::setSelectable, QCPAbstractPlottable::setSelected

QCPAbstractPlottable * QCustomPlot::plottableAt | ( | const QPointF & | pos,
|  | bool | onlySelectable = `false`
| ) |  | const

Returns the plottable at the pixel position pos. Plottables that only consist of single lines (like graphs) have a tolerance band around them, see setSelectionTolerance. If multiple plottables come into consideration, the one closest to pos is returned.

If onlySelectable is true, only plottables that are selectable (QCPAbstractPlottable::setSelectable) are considered.

If there is no plottable at pos, the return value is 0.

See Also
  itemAt, layoutElementAt

bool QCustomPlot::hasPlottable | ( | QCPAbstractPlottable * | plottable | ) | const

Returns whether this QCustomPlot instance contains the plottable.

See Also
  addPlottable

QCPGraph * QCustomPlot::graph | ( | int | index | ) | const

Returns the graph with index. If the index is invalid, returns 0.

There is an overloaded version of this function with no parameter which returns the last created graph, see QCustomPlot::graph()

See Also
  graphCount, addGraph

QCPGraph * QCustomPlot::graph | ( |  | ) | const

This is an overloaded function.

Returns the last graph, that was created with addGraph. If there are no graphs in the plot, returns 0.

See Also
  graphCount, addGraph

QCPGraph * QCustomPlot::addGraph | ( | QCPAxis * | keyAxis = `0`,
|  | QCPAxis * | valueAxis = `0`
| ) |  |

Creates a new graph inside the plot. If keyAxis and valueAxis are left unspecified (0), the bottom (xAxis) is used as key and the left (yAxis) is used as value axis. If specified, keyAxis and valueAxis must reside in this QCustomPlot.

keyAxis will be used as key axis (typically "x") and valueAxis as value axis (typically "y") for the graph.

Returns a pointer to the newly created graph, or 0 if adding the graph failed.

See Also
  graph, graphCount, removeGraph, clearGraphs

bool QCustomPlot::removeGraph | ( | QCPGraph * | graph | ) |

Removes the specified graph from the plot and, if necessary, from the QCustomPlot::legend. If any other graphs in the plot have a channel fill set towards the removed graph, the channel fill property of those graphs is reset to zero (no channel fill).

Returns true on success.

See Also
  clearGraphs

bool QCustomPlot::removeGraph | ( | int | index | ) |

This is an overloaded function.

Removes the graph by its index.

int QCustomPlot::clearGraphs | ( |  | ) |

Removes all graphs from the plot (and the QCustomPlot::legend, if necessary).

Returns the number of graphs removed.

See Also
  removeGraph

int QCustomPlot::graphCount | ( |  | ) | const

Returns the number of currently existing graphs in the plot

See Also
  graph, addGraph

QList< QCPGraph * > QCustomPlot::selectedGraphs | ( |  | ) | const

Returns a list of the selected graphs. If no graphs are currently selected, the list is empty.

If you are not only interested in selected graphs but other plottables like QCPCurve, QCPBars, etc., use selectedPlottables.

See Also
  setInteractions, selectedPlottables, QCPAbstractPlottable::setSelectable, QCPAbstractPlottable::setSelected

QCPAbstractItem * QCustomPlot::item | ( | int | index | ) | const

Returns the item with index. If the index is invalid, returns 0.

There is an overloaded version of this function with no parameter which returns the last added item, see QCustomPlot::item()

See Also
  itemCount, addItem

QCPAbstractItem * QCustomPlot::item | ( |  | ) | const

This is an overloaded function.

Returns the last item, that was added with addItem. If there are no items in the plot, returns 0.

See Also
  itemCount, addItem

bool QCustomPlot::addItem | ( | QCPAbstractItem * | item | ) |

Adds the specified item to the plot. QCustomPlot takes ownership of the item.

Returns true on success, i.e. when item wasn't already in the plot and the parent plot of item is this QCustomPlot.

See Also
  item, itemCount, removeItem, clearItems

bool QCustomPlot::removeItem | ( | QCPAbstractItem * | item | ) |

Removes the specified item from the plot.

Returns true on success.

See Also
  addItem, clearItems

bool QCustomPlot::removeItem | ( | int | index | ) |

This is an overloaded function.

Removes the item by its index.

int QCustomPlot::clearItems | ( |  | ) |

Removes all items from the plot.

Returns the number of items removed.

See Also
  removeItem

int QCustomPlot::itemCount | ( |  | ) | const

Returns the number of currently existing items in the plot

See Also
  item, addItem

QList< QCPAbstractItem * > QCustomPlot::selectedItems | ( |  | ) | const

Returns a list of the selected items. If no items are currently selected, the list is empty.

See Also
  setInteractions, QCPAbstractItem::setSelectable, QCPAbstractItem::setSelected

QCPAbstractItem * QCustomPlot::itemAt | ( | const QPointF & | pos,
|  | bool | onlySelectable = `false`
| ) |  | const

Returns the item at the pixel position pos. Items that only consist of single lines (e.g. QCPItemLine or QCPItemCurve) have a tolerance band around them, see setSelectionTolerance. If multiple items come into consideration, the one closest to pos is returned.

If onlySelectable is true, only items that are selectable (QCPAbstractItem::setSelectable) are considered.

If there is no item at pos, the return value is 0.

See Also
  plottableAt, layoutElementAt

bool QCustomPlot::hasItem | ( | QCPAbstractItem * | item | ) | const

Returns whether this QCustomPlot contains the item.

See Also
  addItem

QCPLayer * QCustomPlot::layer | ( | const QString & | name | ) | const

Returns the layer with the specified name. If there is no layer with the specified name, 0 is returned.

Layer names are case-sensitive.

See Also
  addLayer, moveLayer, removeLayer

QCPLayer * QCustomPlot::layer | ( | int | index | ) | const

This is an overloaded function.

Returns the layer by index. If the index is invalid, 0 is returned.

See Also
  addLayer, moveLayer, removeLayer

QCPLayer * QCustomPlot::currentLayer | ( |  | ) | const

Returns the layer that is set as current layer (see setCurrentLayer).

bool QCustomPlot::setCurrentLayer | ( | const QString & | name | ) |

Sets the layer with the specified name to be the current layer. All layerables (QCPLayerable), e.g. plottables and items, are created on the current layer.

Returns true on success, i.e. if there is a layer with the specified name in the QCustomPlot.

Layer names are case-sensitive.

See Also
  addLayer, moveLayer, removeLayer, QCPLayerable::setLayer

bool QCustomPlot::setCurrentLayer | ( | QCPLayer * | layer | ) |

This is an overloaded function.

Sets the provided layer to be the current layer.

Returns true on success, i.e. when layer is a valid layer in the QCustomPlot.

See Also
  addLayer, moveLayer, removeLayer

int QCustomPlot::layerCount | ( |  | ) | const

Returns the number of currently existing layers in the plot

See Also
  layer, addLayer

bool QCustomPlot::addLayer | ( | const QString & | name,
|  | QCPLayer * | otherLayer = `0`,
|  | QCustomPlot::LayerInsertMode | insertMode = `limAbove`
| ) |  |

Adds a new layer to this QCustomPlot instance. The new layer will have the name name, which must be unique. Depending on insertMode, it is positioned either below or above otherLayer.

Returns true on success, i.e. if there is no other layer named name and otherLayer is a valid layer inside this QCustomPlot.

If otherLayer is 0, the highest layer in the QCustomPlot will be used.

For an explanation of what layers are in QCustomPlot, see the documentation of QCPLayer.

See Also
  layer, moveLayer, removeLayer

bool QCustomPlot::removeLayer | ( | QCPLayer * | layer | ) |

Removes the specified layer and returns true on success.

All layerables (e.g. plottables and items) on the removed layer will be moved to the layer below layer. If layer is the bottom layer, the layerables are moved to the layer above. In both cases, the total rendering order of all layerables in the QCustomPlot is preserved.

If layer is the current layer (setCurrentLayer), the layer below (or above, if bottom layer) becomes the new current layer.

It is not possible to remove the last layer of the plot.

See Also
  layer, addLayer, moveLayer

bool QCustomPlot::moveLayer | ( | QCPLayer * | layer,
|  | QCPLayer * | otherLayer,
|  | QCustomPlot::LayerInsertMode | insertMode = `limAbove`
| ) |  |

Moves the specified layer either above or below otherLayer. Whether it's placed above or below is controlled with insertMode.

Returns true on success, i.e. when both layer and otherLayer are valid layers in the QCustomPlot.

See Also
  layer, addLayer, moveLayer

int QCustomPlot::axisRectCount | ( |  | ) | const

Returns the number of axis rects in the plot.

All axis rects can be accessed via QCustomPlot::axisRect().

Initially, only one axis rect exists in the plot.

See Also
  axisRect, axisRects

QCPAxisRect * QCustomPlot::axisRect | ( | int | index = `0` | ) | const

Returns the axis rect with index.

Initially, only one axis rect (with index 0) exists in the plot. If multiple axis rects were added, all of them may be accessed with this function in a linear fashion (even when they are nested in a layout hierarchy or inside other axis rects via QCPAxisRect::insetLayout).

See Also
  axisRectCount, axisRects

QList< QCPAxisRect * > QCustomPlot::axisRects | ( |  | ) | const

Returns all axis rects in the plot.

See Also
  axisRectCount, axisRect

QCPLayoutElement * QCustomPlot::layoutElementAt | ( | const QPointF & | pos | ) | const

Returns the layout element at pixel position pos. If there is no element at that position, returns 0.

Only visible elements are used. If QCPLayoutElement::setVisible on the element itself or on any of its parent elements is set to false, it will not be considered.

See Also
  itemAt, plottableAt

void QCustomPlot::rescaleAxes | ( | bool | onlyVisiblePlottables = `false` | ) |

Rescales the axes such that all plottables (like graphs) in the plot are fully visible.

if onlyVisiblePlottables is set to true, only the plottables that have their visibility set to true (QCPLayerable::setVisible), will be used to rescale the axes.

See Also
  QCPAbstractPlottable::rescaleAxes, QCPAxis::rescale

QList< QCPAxis * > QCustomPlot::selectedAxes | ( |  | ) | const

Returns the axes that currently have selected parts, i.e. whose selection state is not QCPAxis::spNone.

See Also
  selectedPlottables, selectedLegends, setInteractions, QCPAxis::setSelectedParts, QCPAxis::setSelectableParts

QList< QCPLegend * > QCustomPlot::selectedLegends | ( |  | ) | const

Returns the legends that currently have selected parts, i.e. whose selection state is not QCPLegend::spNone.

See Also
  selectedPlottables, selectedAxes, setInteractions, QCPLegend::setSelectedParts, QCPLegend::setSelectableParts, QCPLegend::selectedItems

void QCustomPlot::deselectAll | ( |  | ) |

Deselects all layerables (plottables, items, axes, legends,...) of the QCustomPlot.

Since calling this function is not a user interaction, this does not emit the selectionChangedByUser signal. The individual selectionChanged signals are emitted though, if the objects were previously selected.

See Also
  setInteractions, selectedPlottables, selectedItems, selectedAxes, selectedLegends

bool QCustomPlot::savePdf | ( | const QString & | fileName,
|  | bool | noCosmeticPen = `false`,
|  | int | width = `0`,
|  | int | height = `0`,
|  | const QString & | pdfCreator = `""`,
|  | const QString & | pdfTitle = `""`
| ) |  |

Saves a PDF with the vectorized plot to the file fileName. The axis ratio as well as the scale of texts and lines will be derived from the specified width and height. This means, the output will look like the normal on-screen output of a QCustomPlot widget with the corresponding pixel width and height. If either width or height is zero, the exported image will have the same dimensions as the QCustomPlot widget currently has.

noCosmeticPen disables the use of cosmetic pens when drawing to the PDF file. Cosmetic pens are pens with numerical width 0, which are always drawn as a one pixel wide line, no matter what zoom factor is set in the PDF-Viewer. For more information about cosmetic pens, see the QPainter and QPen documentation.

The objects of the plot will appear in the current selection state. If you don't want any selected objects to be painted in their selected look, deselect everything with deselectAll before calling this function.

Returns true on success.

Warning
  - If you plan on editing the exported PDF file with a vector graphics editor like Inkscape, it is advised to set noCosmeticPen to true to avoid losing those cosmetic lines (which might be quite many, because cosmetic pens are the default for e.g. axes and tick marks).
  - If calling this function inside the constructor of the parent of the QCustomPlot widget (i.e. the MainWindow constructor, if QCustomPlot is inside the MainWindow), always provide explicit non-zero widths and heights. If you leave width or height as 0 (default), this function uses the current width and height of the QCustomPlot widget. However, in Qt, these aren't defined yet inside the constructor, so you would get an image that has strange widths/heights.
  pdfCreator and pdfTitle may be used to set the according metadata fields in the resulting PDF file.

Note
  On Android systems, this method does nothing and issues an according qDebug warning message. This is also the case if for other reasons the define flag QT_NO_PRINTER is set.

See Also
  savePng, saveBmp, saveJpg, saveRastered

bool QCustomPlot::savePng | ( | const QString & | fileName,
|  | int | width = `0`,
|  | int | height = `0`,
|  | double | scale = `1.0`,
|  | int | quality = `-1`
| ) |  |

Saves a PNG image file to fileName on disc. The output plot will have the dimensions width and height in pixels. If either width or height is zero, the exported image will have the same dimensions as the QCustomPlot widget currently has. Line widths and texts etc. are not scaled up when larger widths/heights are used. If you want that effect, use the scale parameter.

For example, if you set both width and height to 100 and scale to 2, you will end up with an image file of size 200*200 in which all graphical elements are scaled up by factor 2 (line widths, texts, etc.). This scaling is not done by stretching a 100*100 image, the result will have full 200*200 pixel resolution.

If you use a high scaling factor, it is recommended to enable antialiasing for all elements via temporarily setting QCustomPlot::setAntialiasedElements to QCP::aeAll as this allows QCustomPlot to place objects with sub-pixel accuracy.

Warning
  If calling this function inside the constructor of the parent of the QCustomPlot widget (i.e. the MainWindow constructor, if QCustomPlot is inside the MainWindow), always provide explicit non-zero widths and heights. If you leave width or height as 0 (default), this function uses the current width and height of the QCustomPlot widget. However, in Qt, these aren't defined yet inside the constructor, so you would get an image that has strange widths/heights.

The objects of the plot will appear in the current selection state. If you don't want any selected objects to be painted in their selected look, deselect everything with deselectAll before calling this function.

If you want the PNG to have a transparent background, call setBackground(const QBrush &brush) with no brush (Qt::NoBrush) or a transparent color (Qt::transparent), before saving.

PNG compression can be controlled with the quality parameter which must be between 0 and 100 or -1 to use the default setting.

Returns true on success. If this function fails, most likely the PNG format isn't supported by the system, see Qt docs about QImageWriter::supportedImageFormats().

See Also
  savePdf, saveBmp, saveJpg, saveRastered

bool QCustomPlot::saveJpg | ( | const QString & | fileName,
|  | int | width = `0`,
|  | int | height = `0`,
|  | double | scale = `1.0`,
|  | int | quality = `-1`
| ) |  |

Saves a JPG image file to fileName on disc. The output plot will have the dimensions width and height in pixels. If either width or height is zero, the exported image will have the same dimensions as the QCustomPlot widget currently has. Line widths and texts etc. are not scaled up when larger widths/heights are used. If you want that effect, use the scale parameter.

For example, if you set both width and height to 100 and scale to 2, you will end up with an image file of size 200*200 in which all graphical elements are scaled up by factor 2 (line widths, texts, etc.). This scaling is not done by stretching a 100*100 image, the result will have full 200*200 pixel resolution.

If you use a high scaling factor, it is recommended to enable antialiasing for all elements via temporarily setting QCustomPlot::setAntialiasedElements to QCP::aeAll as this allows QCustomPlot to place objects with sub-pixel accuracy.

Warning
  If calling this function inside the constructor of the parent of the QCustomPlot widget (i.e. the MainWindow constructor, if QCustomPlot is inside the MainWindow), always provide explicit non-zero widths and heights. If you leave width or height as 0 (default), this function uses the current width and height of the QCustomPlot widget. However, in Qt, these aren't defined yet inside the constructor, so you would get an image that has strange widths/heights.

The objects of the plot will appear in the current selection state. If you don't want any selected objects to be painted in their selected look, deselect everything with deselectAll before calling this function.

JPG compression can be controlled with the quality parameter which must be between 0 and 100 or -1 to use the default setting.

Returns true on success. If this function fails, most likely the JPG format isn't supported by the system, see Qt docs about QImageWriter::supportedImageFormats().

See Also
  savePdf, savePng, saveBmp, saveRastered

bool QCustomPlot::saveBmp | ( | const QString & | fileName,
|  | int | width = `0`,
|  | int | height = `0`,
|  | double | scale = `1.0`
| ) |  |

Saves a BMP image file to fileName on disc. The output plot will have the dimensions width and height in pixels. If either width or height is zero, the exported image will have the same dimensions as the QCustomPlot widget currently has. Line widths and texts etc. are not scaled up when larger widths/heights are used. If you want that effect, use the scale parameter.

For example, if you set both width and height to 100 and scale to 2, you will end up with an image file of size 200*200 in which all graphical elements are scaled up by factor 2 (line widths, texts, etc.). This scaling is not done by stretching a 100*100 image, the result will have full 200*200 pixel resolution.

If you use a high scaling factor, it is recommended to enable antialiasing for all elements via temporarily setting QCustomPlot::setAntialiasedElements to QCP::aeAll as this allows QCustomPlot to place objects with sub-pixel accuracy.

Warning
  If calling this function inside the constructor of the parent of the QCustomPlot widget (i.e. the MainWindow constructor, if QCustomPlot is inside the MainWindow), always provide explicit non-zero widths and heights. If you leave width or height as 0 (default), this function uses the current width and height of the QCustomPlot widget. However, in Qt, these aren't defined yet inside the constructor, so you would get an image that has strange widths/heights.

The objects of the plot will appear in the current selection state. If you don't want any selected objects to be painted in their selected look, deselect everything with deselectAll before calling this function.

Returns true on success. If this function fails, most likely the BMP format isn't supported by the system, see Qt docs about QImageWriter::supportedImageFormats().

See Also
  savePdf, savePng, saveJpg, saveRastered

bool QCustomPlot::saveRastered | ( | const QString & | fileName,
|  | int | width,
|  | int | height,
|  | double | scale,
|  | const char * | format,
|  | int | quality = `-1`
| ) |  |

Saves the plot to a rastered image file fileName in the image format format. The plot is sized to width and height in pixels and scaled with scale. (width 100 and scale 2.0 lead to a full resolution file with width 200.) If the format supports compression, quality may be between 0 and 100 to control it.

Returns true on success. If this function fails, most likely the given format isn't supported by the system, see Qt docs about QImageWriter::supportedImageFormats().

See Also
  saveBmp, saveJpg, savePng, savePdf

QPixmap QCustomPlot::toPixmap | ( | int | width = `0`,
|  | int | height = `0`,
|  | double | scale = `1.0`
| ) |  |

Renders the plot to a pixmap and returns it.

The plot is sized to width and height in pixels and scaled with scale. (width 100 and scale 2.0 lead to a full resolution pixmap with width 200.)

See Also
  toPainter, saveRastered, saveBmp, savePng, saveJpg, savePdf

void QCustomPlot::toPainter | ( | QCPPainter * | painter,
|  | int | width = `0`,
|  | int | height = `0`
| ) |  |

Renders the plot using the passed painter.

The plot is sized to width and height in pixels. If the painter's scale is not 1.0, the resulting plot will appear scaled accordingly.

Note
  If you are restricted to using a QPainter (instead of QCPPainter), create a temporary QPicture and open a QCPPainter on it. Then call toPainter with this QCPPainter. After ending the paint operation on the picture, draw it with the QPainter. This will reproduce the painter actions the QCPPainter took, with a QPainter.

See Also
  toPixmap

void QCustomPlot::replot | ( | QCustomPlot::RefreshPriority | refreshPriority = `QCustomPlot::rpHint` | ) |

Causes a complete replot into the internal buffer. Finally, update() is called, to redraw the buffer on the QCustomPlot widget surface. This is the method that must be called to make changes, for example on the axis ranges or data points of graphs, visible.

Under a few circumstances, QCustomPlot causes a replot by itself. Those are resize events of the QCustomPlot widget and user interactions (object selection and range dragging/zooming).

Before the replot happens, the signal beforeReplot is emitted. After the replot, afterReplot is emitted. It is safe to mutually connect the replot slot with any of those two signals on two QCustomPlots to make them replot synchronously, it won't cause an infinite recursion.

void QCustomPlot::mouseDoubleClick | ( | QMouseEvent * | event | ) |
| signal

This signal is emitted when the QCustomPlot receives a mouse double click event.

void QCustomPlot::mousePress | ( | QMouseEvent * | event | ) |
| signal

This signal is emitted when the QCustomPlot receives a mouse press event.

It is emitted before QCustomPlot handles any other mechanism like range dragging. So a slot connected to this signal can still influence the behaviour e.g. with QCPAxisRect::setRangeDrag or QCPAxisRect::setRangeDragAxes.

void QCustomPlot::mouseMove | ( | QMouseEvent * | event | ) |
| signal

This signal is emitted when the QCustomPlot receives a mouse move event.

It is emitted before QCustomPlot handles any other mechanism like range dragging. So a slot connected to this signal can still influence the behaviour e.g. with QCPAxisRect::setRangeDrag or QCPAxisRect::setRangeDragAxes.

Warning
  It is discouraged to change the drag-axes with QCPAxisRect::setRangeDragAxes here, because the dragging starting point was saved the moment the mouse was pressed. Thus it only has a meaning for the range drag axes that were set at that moment. If you want to change the drag axes, consider doing this in the mousePress signal instead.

void QCustomPlot::mouseRelease | ( | QMouseEvent * | event | ) |
| signal

This signal is emitted when the QCustomPlot receives a mouse release event.

It is emitted before QCustomPlot handles any other mechanisms like object selection. So a slot connected to this signal can still influence the behaviour e.g. with setInteractions or QCPAbstractPlottable::setSelectable.

void QCustomPlot::mouseWheel | ( | QWheelEvent * | event | ) |
| signal

This signal is emitted when the QCustomPlot receives a mouse wheel event.

It is emitted before QCustomPlot handles any other mechanisms like range zooming. So a slot connected to this signal can still influence the behaviour e.g. with QCPAxisRect::setRangeZoom, QCPAxisRect::setRangeZoomAxes or QCPAxisRect::setRangeZoomFactor.

void QCustomPlot::plottableClick | ( | QCPAbstractPlottable * | plottable,
|  | QMouseEvent * | event
| ) |  |
| signal

This signal is emitted when a plottable is clicked.

event is the mouse event that caused the click and plottable is the plottable that received the click.

See Also
  plottableDoubleClick

void QCustomPlot::plottableDoubleClick | ( | QCPAbstractPlottable * | plottable,
|  | QMouseEvent * | event
| ) |  |
| signal

This signal is emitted when a plottable is double clicked.

event is the mouse event that caused the click and plottable is the plottable that received the click.

See Also
  plottableClick

void QCustomPlot::itemClick | ( | QCPAbstractItem * | item,
|  | QMouseEvent * | event
| ) |  |
| signal

This signal is emitted when an item is clicked.

event is the mouse event that caused the click and item is the item that received the click.

See Also
  itemDoubleClick

void QCustomPlot::itemDoubleClick | ( | QCPAbstractItem * | item,
|  | QMouseEvent * | event
| ) |  |
| signal

This signal is emitted when an item is double clicked.

event is the mouse event that caused the click and item is the item that received the click.

See Also
  itemClick

void QCustomPlot::axisClick | ( | QCPAxis * | axis,
|  | QCPAxis::SelectablePart | part,
|  | QMouseEvent * | event
| ) |  |
| signal

This signal is emitted when an axis is clicked.

event is the mouse event that caused the click, axis is the axis that received the click and part indicates the part of the axis that was clicked.

See Also
  axisDoubleClick

void QCustomPlot::axisDoubleClick | ( | QCPAxis * | axis,
|  | QCPAxis::SelectablePart | part,
|  | QMouseEvent * | event
| ) |  |
| signal

This signal is emitted when an axis is double clicked.

event is the mouse event that caused the click, axis is the axis that received the click and part indicates the part of the axis that was clicked.

See Also
  axisClick

void QCustomPlot::legendClick | ( | QCPLegend * | legend,
|  | QCPAbstractLegendItem * | item,
|  | QMouseEvent * | event
| ) |  |
| signal

This signal is emitted when a legend (item) is clicked.

event is the mouse event that caused the click, legend is the legend that received the click and item is the legend item that received the click. If only the legend and no item is clicked, item is 0. This happens for a click inside the legend padding or the space between two items.

See Also
  legendDoubleClick

void QCustomPlot::legendDoubleClick | ( | QCPLegend * | legend,
|  | QCPAbstractLegendItem * | item,
|  | QMouseEvent * | event
| ) |  |
| signal

This signal is emitted when a legend (item) is double clicked.

event is the mouse event that caused the click, legend is the legend that received the click and item is the legend item that received the click. If only the legend and no item is clicked, item is 0. This happens for a click inside the legend padding or the space between two items.

See Also
  legendClick

void QCustomPlot::titleClick | ( | QMouseEvent * | event,
|  | QCPPlotTitle * | title
| ) |  |
| signal

This signal is emitted when a plot title is clicked.

event is the mouse event that caused the click and title is the plot title that received the click.

See Also
  titleDoubleClick

void QCustomPlot::titleDoubleClick | ( | QMouseEvent * | event,
|  | QCPPlotTitle * | title
| ) |  |
| signal

This signal is emitted when a plot title is double clicked.

event is the mouse event that caused the click and title is the plot title that received the click.

See Also
  titleClick

void QCustomPlot::selectionChangedByUser | ( |  | ) |
| signal

This signal is emitted after the user has changed the selection in the QCustomPlot, e.g. by clicking. It is not emitted when the selection state of an object has changed programmatically by a direct call to setSelected() on an object or by calling deselectAll.

In addition to this signal, selectable objects also provide individual signals, for example QCPAxis::selectionChanged or QCPAbstractPlottable::selectionChanged. Note that those signals are emitted even if the selection state is changed programmatically.

See the documentation of setInteractions for details about the selection mechanism.

See Also
  selectedPlottables, selectedGraphs, selectedItems, selectedAxes, selectedLegends

void QCustomPlot::beforeReplot | ( |  | ) |
| signal

This signal is emitted immediately before a replot takes place (caused by a call to the slot replot).

It is safe to mutually connect the replot slot with this signal on two QCustomPlots to make them replot synchronously, it won't cause an infinite recursion.

See Also
  replot, afterReplot

void QCustomPlot::afterReplot | ( |  | ) |
| signal

This signal is emitted immediately after a replot has taken place (caused by a call to the slot replot).

It is safe to mutually connect the replot slot with this signal on two QCustomPlots to make them replot synchronously, it won't cause an infinite recursion.

See Also
  replot, beforeReplot

QSize QCustomPlot::minimumSizeHint | ( |  | ) | const
| protected virtual

Returns a minimum size hint that corresponds to the minimum size of the top level layout (plotLayout). To prevent QCustomPlot from being collapsed to size/width zero, set a minimum size (setMinimumSize) either on the whole QCustomPlot or on any layout elements inside the plot. This is especially important, when placed in a QLayout where other components try to take in as much space as possible (e.g. QMdiArea).

QSize QCustomPlot::sizeHint | ( |  | ) | const
| protected virtual

Returns a size hint that is the same as minimumSizeHint.

void QCustomPlot::paintEvent | ( | QPaintEvent * | event | ) |
| protected virtual

Event handler for when the QCustomPlot widget needs repainting. This does not cause a replot, but draws the internal buffer on the widget surface.

void QCustomPlot::resizeEvent | ( | QResizeEvent * | event | ) |
| protected virtual

Event handler for a resize of the QCustomPlot widget. Causes the internal buffer to be resized to the new size. The viewport (which becomes the outer rect of mPlotLayout) is resized appropriately. Finally a replot is performed.

void QCustomPlot::mouseDoubleClickEvent | ( | QMouseEvent * | event | ) |
| protected virtual

Event handler for when a double click occurs. Emits the mouseDoubleClick signal, then emits the specialized signals when certain objecs are clicked (e.g. plottableDoubleClick, axisDoubleClick, etc.). Finally determines the affected layout element and forwards the event to it.

See Also
  mousePressEvent, mouseReleaseEvent

void QCustomPlot::mousePressEvent | ( | QMouseEvent * | event | ) |
| protected virtual

Event handler for when a mouse button is pressed. Emits the mousePress signal. Then determines the affected layout element and forwards the event to it.

See Also
  mouseMoveEvent, mouseReleaseEvent

void QCustomPlot::mouseMoveEvent | ( | QMouseEvent * | event | ) |
| protected virtual

Event handler for when the cursor is moved. Emits the mouseMove signal.

If a layout element has mouse capture focus (a mousePressEvent happened on top of the layout element before), the mouseMoveEvent is forwarded to that element.

See Also
  mousePressEvent, mouseReleaseEvent

void QCustomPlot::mouseReleaseEvent | ( | QMouseEvent * | event | ) |
| protected virtual

Event handler for when a mouse button is released. Emits the mouseRelease signal.

If the mouse was moved less than a certain threshold in any direction since the mousePressEvent, it is considered a click which causes the selection mechanism (if activated via setInteractions) to possibly change selection states accordingly. Further, specialized mouse click signals are emitted (e.g. plottableClick, axisClick, etc.)

If a layout element has mouse capture focus (a mousePressEvent happened on top of the layout element before), the mouseReleaseEvent is forwarded to that element.

See Also
  mousePressEvent, mouseMoveEvent

void QCustomPlot::wheelEvent | ( | QWheelEvent * | event | ) |
| protected virtual

Event handler for mouse wheel events. First, the mouseWheel signal is emitted. Then determines the affected layout element and forwards the event to it.

void QCustomPlot::draw | ( | QCPPainter * | painter | ) |
| protected virtual

This is the main draw function. It draws the entire plot, including background pixmap, with the specified painter. Note that it does not fill the background with the background brush (as the user may specify with setBackground(const QBrush &brush)), this is up to the respective functions calling this method (e.g. replot, toPixmap and toPainter).

void QCustomPlot::axisRemoved | ( | QCPAxis * | axis | ) |
| protected virtual

This method is used by QCPAxisRect::removeAxis to report removed axes to the QCustomPlot so it may clear its QCustomPlot::xAxis, yAxis, xAxis2 and yAxis2 members accordingly.

void QCustomPlot::legendRemoved | ( | QCPLegend * | legend | ) |
| protected virtual

This method is used by the QCPLegend destructor to report legend removal to the QCustomPlot so it may clear its QCustomPlot::legend member accordingly.

void QCustomPlot::updateLayerIndices | ( |  | ) | const
| protected

Assigns all layers their index (QCPLayer::mIndex) in the mLayers list. This method is thus called after every operation that changes the layer indices, like layer removal, layer creation, layer moving.

QCPLayerable * QCustomPlot::layerableAt | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | selectionDetails = `0`
| ) |  | const
| protected

Returns the layerable at pixel position pos. If onlySelectable is set to true, only those layerables that are selectable will be considered. (Layerable subclasses communicate their selectability via the QCPLayerable::selectTest method, by returning -1.)

selectionDetails is an output parameter that contains selection specifics of the affected layerable. This is useful if the respective layerable shall be given a subsequent QCPLayerable::selectEvent (like in mouseReleaseEvent). selectionDetails usually contains information about which part of the layerable was hit, in multi-part layerables (e.g. QCPAxis::SelectablePart).

void QCustomPlot::drawBackground | ( | QCPPainter * | painter | ) |
| protected

Draws the viewport background pixmap of the plot.

If a pixmap was provided via setBackground, this function buffers the scaled version depending on setBackgroundScaled and setBackgroundScaledMode and then draws it inside the viewport with the provided painter. The scaled version is buffered in mScaledBackgroundPixmap to prevent expensive rescaling at every redraw. It is only updated, when the axis rect has changed in a way that requires a rescale of the background pixmap (this is dependent on the setBackgroundScaledMode), or when a differend axis background pixmap was set.

Note that this function does not draw a fill with the background brush (setBackground(const QBrush &brush)) beneath the pixmap.

See Also
  setBackground, setBackgroundScaled, setBackgroundScaledMode

## Field Documentation

QCPAxis * QCustomPlot::xAxis

A pointer to the primary x Axis (bottom) of the main axis rect of the plot.

QCustomPlot offers convenient pointers to the axes (xAxis, yAxis, xAxis2, yAxis2) and the legend. They make it very easy working with plots that only have a single axis rect and at most one axis at each axis rect side. If you use the layout system to add multiple axis rects or multiple axes to one side, use the QCPAxisRect::axis interface to access the new axes. If one of the four default axes or the default legend is removed due to manipulation of the layout system (e.g. by removing the main axis rect), the corresponding pointers become 0.

QCPAxis * QCustomPlot::yAxis

A pointer to the primary y Axis (left) of the main axis rect of the plot.

QCustomPlot offers convenient pointers to the axes (xAxis, yAxis, xAxis2, yAxis2) and the legend. They make it very easy working with plots that only have a single axis rect and at most one axis at each axis rect side. If you use the layout system to add multiple axis rects or multiple axes to one side, use the QCPAxisRect::axis interface to access the new axes. If one of the four default axes or the default legend is removed due to manipulation of the layout system (e.g. by removing the main axis rect), the corresponding pointers become 0.

QCPAxis * QCustomPlot::xAxis2

A pointer to the secondary x Axis (top) of the main axis rect of the plot. Secondary axes are invisible by default. Use QCPAxis::setVisible to change this (or use QCPAxisRect::setupFullAxesBox).

QCustomPlot offers convenient pointers to the axes (xAxis, yAxis, xAxis2, yAxis2) and the legend. They make it very easy working with plots that only have a single axis rect and at most one axis at each axis rect side. If you use the layout system to add multiple axis rects or multiple axes to one side, use the QCPAxisRect::axis interface to access the new axes. If one of the four default axes or the default legend is removed due to manipulation of the layout system (e.g. by removing the main axis rect), the corresponding pointers become 0.

QCPAxis * QCustomPlot::yAxis2

A pointer to the secondary y Axis (right) of the main axis rect of the plot. Secondary axes are invisible by default. Use QCPAxis::setVisible to change this (or use QCPAxisRect::setupFullAxesBox).

QCustomPlot offers convenient pointers to the axes (xAxis, yAxis, xAxis2, yAxis2) and the legend. They make it very easy working with plots that only have a single axis rect and at most one axis at each axis rect side. If you use the layout system to add multiple axis rects or multiple axes to one side, use the QCPAxisRect::axis interface to access the new axes. If one of the four default axes or the default legend is removed due to manipulation of the layout system (e.g. by removing the main axis rect), the corresponding pointers become 0.

QCPLegend * QCustomPlot::legend

A pointer to the default legend of the main axis rect. The legend is invisible by default. Use QCPLegend::setVisible to change this.

QCustomPlot offers convenient pointers to the axes (xAxis, yAxis, xAxis2, yAxis2) and the legend. They make it very easy working with plots that only have a single axis rect and at most one axis at each axis rect side. If you use the layout system to add multiple legends to the plot, use the layout system interface to access the new legend. For example, legends can be placed inside an axis rect's inset layout, and must then also be accessed via the inset layout. If the default legend is removed due to manipulation of the layout system (e.g. by removing the main axis rect), the corresponding pointer becomes 0.

The documentation for this class was generated from the following files:

- src/core.h
- src/core.cpp

Generated with Doxygen 1.8.1.2